// A class based implementation of "improved Perlin noise". Refer to,
//  http://fundza.com/c4serious/noise/perlin/index.html
// for details.
// Malcolm Kesson
// March 2019

#include <ri.h>

class PNoise3D {
    public:
        PNoise3D( );//float x, float y, float z);
        virtual ~PNoise3D() { };

		virtual float eval(float x, float y, float z, float freq);
		virtual float eval(RtFloat3 pos, float freq);
		virtual float remap(float val, float minval, float maxval);
    private:
        virtual float fade(float t);
		virtual float lerp(float t, float a, float b);
		virtual float grad(int hash, float x, float y, float z);
        int m_p[512];
    };
